import { PropTypes } from 'react';
import intersection from 'lodash.intersection';


const uiColorModifiers = [
    'blue', 'informative',
    'dark-gray', 'active',
    'gray', 'default',
    'red', 'danger',
    'teal', 'primary',
    'white', 'secondary',
    'link'
];

const uiModifiers = PropTypes.oneOf([
    ...uiColorModifiers,
    'mobile-stretched',
    'mobile-tablet-stretched',
    'stretched'
]);

const defaultUIColorModifier = 'default';

export default {
    uiPropDefaultType: PropTypes.oneOfType([
        uiModifiers,
        PropTypes.arrayOf(uiModifiers)
    ]),
    uiPropDefaultValue: defaultUIColorModifier,
    uiPropGetValue: (ui) => {
        const uiArray = typeof ui === 'string' ? [ui] : ui;
        const hasUIColorModifier = intersection(uiArray, uiColorModifiers).length > 0;

        return hasUIColorModifier ? uiArray : [defaultUIColorModifier, ...uiArray];
    }
};
