export const type = 'BILLOGRAM-FOUNDATION.COMPONENT-MOUNT';

export default ({ initialComponentState, root }) => {
    return {
        type,
        meta: {
            root
        },
        payload: initialComponentState
    };
};

export const reducer = {
    [type]: (state, action) => {
        const { root } = action.meta;
        if (state[root] !== undefined && state.meta.mounted[action.meta.root]) {
            return state;
        }

        return state
            .set(root, action.payload)
            .setIn(['meta', 'mounted'], { ...state.meta.mounted, [root]: true });
    }
};
