import isNullOrEmpty from '../isNullOrEmpty';


const stringToArray = (str) => {
    return str.split('.').reduce((result, token) => {
        const matches = token.match(/\[(.*?)\]/);
        if (matches !== null && matches.length >= 2) {
            return [...result, token.replace(matches[0], ''), matches[1]];
        }

        return [...result, token];
    }, []);
};

// Convert root/path from 'root'/'items[0] to ['root', 'items', '0'].
export default (root, path) => {
    return stringToArray(root).concat(stringToArray(path)).filter((item) => !isNullOrEmpty(item));
};
