import test from 'tape';

import getSeamlessPath from './getSeamlessPath';


test('single root/path', (t) => {
    const result = getSeamlessPath('root', 'path');
    t.same(result, ['root', 'path']);
    t.end();
});

test('dotted path', (t) => {
    const result = getSeamlessPath('root', 'path.to');
    t.same(result, ['root', 'path', 'to']);
    t.end();
});

test('dotted root', (t) => {
    const result = getSeamlessPath('root.to', 'path');
    t.same(result, ['root', 'to', 'path']);
    t.end();
});

test('indexed path', (t) => {
    const result = getSeamlessPath('root', 'path[0]');
    t.same(result, ['root', 'path', '0']);
    t.end();
});

test('legacy indexed path', (t) => {
    const result = getSeamlessPath('root', 'path.[0]');
    t.same(result, ['root', 'path', '0']);
    t.end();
});

test('indexed root', (t) => {
    const result = getSeamlessPath('root[0]', 'path');
    t.same(result, ['root', '0', 'path']);
    t.end();
});

test('legacy indexed root', (t) => {
    const result = getSeamlessPath('root.[0]', 'path');
    t.same(result, ['root', '0', 'path']);
    t.end();
});
